DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Protected Member Functions | List of all members
DiCIELABFunction Class Reference

Class to manage CIELAB LUTs (for calibration) More...

Inheritance diagram for DiCIELABFunction:

## Public Member Functions
| DiCIELABFunction (const char *filename, const E_DeviceType deviceType=EDT_Monitor, const signed int ord=-1)
| constructor, read device characteristics file. More...
| DiCIELABFunction (const double *val_tab, const unsigned long count, const Uint16 max=255, const E_DeviceType deviceType=EDT_Monitor, const signed int ord=0)
| constructor, use given array of luminance/OD values. More...
| DiCIELABFunction (const Uint16 *ddl_tab, const double *val_tab, const unsigned long count, const Uint16 max=255, const E_DeviceType deviceType=EDT_Monitor, const signed int ord=0)
| constructor, use given array of DDL and luminance values. More...
| DiCIELABFunction (const double val_min, const double val_max, const unsigned long count=256, const E_DeviceType deviceType=EDT_Monitor, const signed int ord=0)
| constructor, compute luminance/OD values automatically within the specified range. More...
virtual | ~DiCIELABFunction ()
| destructor
int | writeCurveData (const char *filename, const OFBool mode=OFTrue)
| write curve data to a text file More...
Public Member Functions inherited from DiDisplayFunction
| DiDisplayFunction (const char *filename, const E_DeviceType deviceType=EDT_Monitor, const signed int ord=-1)
| constructor, read device characteristics file. More...
| DiDisplayFunction (const double *val_tab, const unsigned long count, const Uint16 max=255, const E_DeviceType deviceType=EDT_Monitor, const signed int ord=0)
| constructor, use given array of luminance/OD values. More...
| DiDisplayFunction (const Uint16 *ddl_tab, const double *val_tab, const unsigned long count, const Uint16 max=255, const E_DeviceType deviceType=EDT_Monitor, const signed int ord=0)
| constructor, use given array of DDL and luminance/OD values. More...
| DiDisplayFunction (const double val_min, const double val_max, const unsigned long count=256, const E_DeviceType deviceType=EDT_Monitor, const signed int ord=0)
| constructor, compute luminance/OD values automatically within the specified range. More...
virtual | ~DiDisplayFunction ()
| destructor
int | isValid () const
| check whether DisplayFunction is valid More...
E_DeviceType | getDeviceType () const
| get output device type (monitor, camera, printer or scanner) More...
Uint16 | getMaxDDLValue () const
| get maximum DDL value. More...
double | getMinValue () const
| get minimum luminance/OD value from the characteristic curve. More...
double | getMaxValue () const
| get maximum luminance/OD value from the characteristic curve. More...
double | getValueforDDL (const Uint16 ddl) const
| get the luminance/OD value for a given DDL. More...
Uint16 | getDDLforValue (const double value) const
| get the DDL for a given luminance/OD value. More...
const DiDisplayLUT * | getLookupTable (const int bits, unsigned long count=0)
| create look-up table with specified number of entries More...
int | deleteLookupTable (const int bits)
| delete specified LUT More...
double | getAmbientLightValue () const
| get (reflected) ambient light value. More...
virtual int | setAmbientLightValue (const double value)
| set (reflected) ambient light value. More...
double | getIlluminationValue () const
| get illumination value. More...
virtual int | setIlluminationValue (const double value)
| set illumination value. More...
double | getMinDensityValue () const
| get minimum optical density value "Dmin". More...
virtual int | setMinDensityValue (const double value)
| set minimum optical density value "Dmin". More...
double | getMaxDensityValue () const
| get maximum optical density value "Dmax". More...
virtual int | setMaxDensityValue (const double value)
| set maximum optical density value "Dmax". More...
double | getMinLuminanceValue () const
| get minimum luminance value "Lmin". More...
double | getMaxLuminanceValue () const
| get maximum luminance value "Lmax". More...
signed int | getPolynomialOrder () const
| get order of the polynomial curve fitting algorithm. More...
double | convertODtoLum (const double value, const OFBool useAmb=OFTrue) const
| convert the given OD value to luminance. More...

## Protected Member Functions
DiDisplayLUT * | getDisplayLUT (unsigned long count)
| create CIELAB LUT with specified number of entries More...
Protected Member Functions inherited from DiDisplayFunction
int | readConfigFile (const char *filename)
| read the given device characteristics file More...
int | createSortedTable (const Uint16 *ddl_tab, const double *val_tab)
| create a sorted (by DDL) table from the given DDL and luminance/OD tables More...
double * | convertODtoLumTable (const double *od_tab, const unsigned long count, const OFBool useAmb)
| create a table with luminance values from the given OD table. More...
int | interpolateValues ()
| interpolate device characteristic curve by means of a cubic spline interpolation
int | calculateMinMax ()
| calculate minimum and maximum luminance/OD values More...
int | checkMinMaxDensity () const
| check whether Dmin and Dmax are properly specified. More...

## Additional Inherited Members
Public Types inherited from DiDisplayFunction
enum | E_DeviceType { EDT_Monitor , EDT_Camera , EDT_Printer , EDT_Scanner }
| output device type More...
Static Public Member Functions inherited from DiDisplayFunction
static double | convertODtoLum (const double value, const double ambient, const double illum)
| convert the given OD value to luminance. More...
Protected Attributes inherited from DiDisplayFunction
int | Valid
| status flag, indicating whether display function is valid
const E_DeviceType | DeviceType
| output device type (monitor, camera, printer or scanner)
unsigned long | ValueCount
| number of DDL and luminance/OD values
Uint16 | MaxDDLValue
| maximum DDL value (usually 255)
signed int | Order
| order of the polynomial curve fitting algorithm
double | AmbientLight
| (reflected) ambient light value
double | Illumination
| illumination value
double | MinDensity
| minimum optical density (-1 if unset)
double | MaxDensity
| maximum optical density (-1 if unset)
Uint16 * | DDLValue
| pointer to array of DDL values
double * | LODValue
| pointer to array of corresponding luminance/OD values
double | MinValue
| minimum luminance/OD value
double | MaxValue
| maximum luminance/OD value
DiDisplayLUT * | LookupTable [MAX_NUMBER_OF_TABLES]
| array with pointer to the different lookup tables (here: 8-16 bits)
Static Protected Attributes inherited from DiDisplayFunction
static const int | MinBits
| constant defining minimum value for number of bits for LUT input (here: 8)
static const int | MaxBits
| constant defining maximum value for number of bits for LUT input (here: 16)

## Detailed Description

Class to manage CIELAB LUTs (for calibration)

## Constructor & Destructor Documentation

## ◆ DiCIELABFunction() [1/4]

DiCIELABFunction::DiCIELABFunction | ( | const char * | filename,
|  | const E_DeviceType | deviceType = `EDT_Monitor`,
|  | const signed int | ord = `-1`
| ) |  |

constructor, read device characteristics file.

Keywords: "max" for maximum DDL (Digital Driving Level, required at first position) "amb" for ambient light and "lum" for illumination (both optional) "ord" for the order of the polynomial curve fitting algorithm used to interpolate the given base points (0 or absent = use cubic spline interpolation)

Parameters

  filename | name of the characteristics file (luminance/OD for each DDL)
  deviceType | type of the output device (default: monitor)
  ord | order of the polynomial curve fitting algorithm used to interpolate the given base points (-1 = use file setting, 0 = cubic spline)

## ◆ DiCIELABFunction() [2/4]

DiCIELABFunction::DiCIELABFunction | ( | const double * | val_tab,
|  | const unsigned long | count,
|  | const Uint16 | max = `255`,
|  | const E_DeviceType | deviceType = `EDT_Monitor`,
|  | const signed int | ord = `0`
| ) |  |

constructor, use given array of luminance/OD values.

UNTESTED Values must be sorted and complete (i.e. there must be an entry for each DDL) The given arrays are copied internally.

Parameters

  val_tab | pointer to array with luminance/OD values
  count | number of array elements (should be equal to 'max + 1')
  max | maximum DDL (digital driving level)
  deviceType | type of the output device (default: monitor)
  ord | order of the polynomial curve fitting algorithm used to interpolate the given base points (0 or negative = use cubic spline interpolation)

## ◆ DiCIELABFunction() [3/4]

DiCIELABFunction::DiCIELABFunction | ( | const Uint16 * | ddl_tab,
|  | const double * | val_tab,
|  | const unsigned long | count,
|  | const Uint16 | max = `255`,
|  | const E_DeviceType | deviceType = `EDT_Monitor`,
|  | const signed int | ord = `0`
| ) |  |

constructor, use given array of DDL and luminance values.

UNTESTED Values will be automatically sorted and missing values will be interpolated. The given arrays are copied internally.

Parameters

  ddl_tab | pointer to array with DDL values (must be with the interval 0..max)
  val_tab | pointer to array with luminance/OD values
  count | number of array elements (2..65536)
  max | maximum DDL (digital driving level)
  deviceType | type of the output device (default: monitor)
  ord | order of the polynomial curve fitting algorithm used to interpolate the given base points (0 or negative = use cubic spline interpolation)

## ◆ DiCIELABFunction() [4/4]

DiCIELABFunction::DiCIELABFunction | ( | const double | val_min,
|  | const double | val_max,
|  | const unsigned long | count = `256`,
|  | const E_DeviceType | deviceType = `EDT_Monitor`,
|  | const signed int | ord = `0`
| ) |  |

constructor, compute luminance/OD values automatically within the specified range.

Parameters

  val_min | minimum luminance/OD value
  val_max | maximum luminance/OD value
  count | number of DDLs (digital driving level, 1..65536))
  deviceType | type of the output device (default: monitor)
  ord | order of the polynomial curve fitting algorithm used to interpolate the given base points (0 or negative = use cubic spline interpolation)

## Member Function Documentation

## ◆ getDisplayLUT()

DiDisplayLUT* DiCIELABFunction::getDisplayLUT | ( | unsigned long | count | ) |
| protected virtual

create CIELAB LUT with specified number of entries

Parameters

  count | number of LUT entries

Returns
  pointer to created LUT if successful, NULL otherwise

Implements DiDisplayFunction.

## ◆ writeCurveData()

int DiCIELABFunction::writeCurveData | ( | const char * | filename,
|  | const OFBool | mode = `OFTrue`
| ) |  |
| virtual

write curve data to a text file

Parameters

  filename | name of the text file to which the data should be written
  mode | write CC and PSC to file if OFTrue

Returns
  status, true if successful, false otherwise

Implements DiDisplayFunction.

The documentation for this class was generated from the following file:

- dcmimgle/include/dcmtk/dcmimgle/diciefn.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1